HDU 5113 Black And White(DFS+剪枝)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5113


题面:

Black And White

Time Limit: 2000/2000 MS (Java/Others)    Memory Limit: 512000/512000 K (Java/Others)
Total Submission(s): 1336    Accepted Submission(s): 350
Special Judge


Problem Description
In mathematics, the four color theorem, or the four color map theorem, states that, given any separation of a plane into contiguous regions, producing a figure called a map, no more than four colors are required to color the regions of the map so that no two adjacent regions have the same color.
— Wikipedia, the free encyclopedia

In this problem, you have to solve the 4-color problem. Hey, I’m just joking.

You are asked to solve a similar problem:

Color an N × M chessboard with K colors numbered from 1 to K such that no two adjacent cells have the same color (two cells are adjacent if they share an edge). The i-th color should be used in exactly c i cells.

Matt hopes you can tell him a possible coloring.
 

Input
The first line contains only one integer T (1 ≤ T ≤ 5000), which indicates the number of test cases.

For each test case, the first line contains three integers: N, M, K (0 < N, M ≤ 5, 0 < K ≤ N × M ).

The second line contains K integers c i (c i > 0), denoting the number of cells where the i-th color should be used.

It’s guaranteed that c 1 + c 2 + · · · + c K = N × M .
 

Output
For each test case, the first line contains “Case #x:”, where x is the case number (starting from 1).

In the second line, output “NO” if there is no coloring satisfying the requirements. Otherwise, output “YES” in one line. Each of the following N lines contains M numbers seperated by single whitespace, denoting the color of the cells.

If there are multiple solutions, output any of them.
 

Sample Input
  
  
4 1 5 2 4 1 3 3 4 1 2 2 4 2 3 3 2 2 2 3 2 3 2 2 2
 

Sample Output
  
  
Case #1: NO Case #2: YES 4 3 4 2 1 2 4 3 4 Case #3: YES 1 2 3 2 3 1 Case #4: YES 1 2 2 3 3 1
 

Source
2014ACM/ICPC亚洲区北京站

解题:
    因为n,m比较小,会想到搜索,但直接超时了。需要加一个剪枝,因为当剩下的容量为n时,任意一种颜色最多只能为(n+1)/2。当任意一种颜色数量超过这个值时,就返回。这个优化已经很厉害了。我又加了一个没什么用的优化,main函数中出现某两种颜色相同时,不用重复计算。

代码:
#include <iostream>
#include <cstdio>
#include <cstring>
#include <queue>
#include <cmath>
#include <cstdlib>
#include <set>
#include <algorithm>
#include <string>
#include <iomanip>
#define LL long long
using namespace std;
int map [7][7],color[30];
int n,m,t,k,sz,amount,tmp;
bool flag=false;
void init()
{
	for(int i=0;i<7;i++)
		map[0][i]=-1;
	for(int j=1;j<7;j++)
		map[j][0]=-1;
}
void dfs(int x,int y,int typ,int lef)
{
  tmp=(lef+1)/2;
  for(int i=1;i<=k;i++)
  {
	  if(color[i]>tmp)
	  return;
  }
  if(flag)return;
  if(color[typ]==0)return;
  if(map[x-1][y]!=typ&&map[x][y-1]!=typ)
  {
	  map[x][y]=typ;
	  color[typ]--;
	  if(x==n&&y==m)
	  {
		  flag=true;
		  return;
	  }
	  else if(y==m)
	  {
		  tmp=0;
		  for(int i=1;i<=k;i++)
		  {
			  if(color[i])tmp++;
		  }
		  if(tmp==1)
		  {
			  if(m!=1)
			  {
				  color[typ]++;
				  return;
			  }
		  }
		  for(int i=1;i<=k;i++)
		  {
			  if(color[i])
				  dfs(x+1,1,i,lef-1);
		  }
	  }
	  else
	  {
		  for(int i=1;i<=k;i++)
		  {
			  if(color[i])
			  {
				  dfs(x,y+1,i,lef-1);
			  }
		  }
	  }
	  color[typ]++;
  }
  return;
}
int main()
{
	init();
	scanf("%d",&t);
	for(int i=1;i<=t;i++)
	{
	  set <int> cnt;
	  printf("Case #%d:\n",i);
      scanf("%d%d%d",&n,&m,&k);
	  amount=(n*m+1)/2;
	  flag=true;
	  if(k==1)
	  {
		  if(n*m!=1)
		  flag=false;
	  }
	  for(int j=1;j<=k;j++)
	  {
		  scanf("%d",&color[j]);
          if(color[j]>amount)
			  flag=false;
	  }
	  if(flag)
	  {
	    flag=false;
	    for(int j=1;j<=k;j++)
	    {
		  sz=cnt.size();
		  if(color[j])
		  {
			  cnt.insert(color[j]);
			  if(cnt.size()>sz)
			  dfs(1,1,j,n*m);
		  }
	    }
	   }
	  if(flag)
	  {
		  printf("YES\n");
		  for(int j=1;j<=n;j++)
		  {
            printf("%d",map[j][1]);
			for(int k=2;k<=m;k++)
				printf(" %d",map[j][k]);
			printf("\n");
		  }
	  }
	  else
	  {
		  printf("NO\n");
	  }
	}
	return 0;
}


 


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值